/*
@C:\WEB_411\Sql\End_Conv\Oracle\5920_FISSTPO_ARQUIVO_DIEF_ES.SQL
 raise_application_error(-20501, '' , True);
*/
CREATE OR REPLACE PROCEDURE ARQUIVO_DIEF_ES(
   P_CDIMPOSTO   IN IMPOSTO.CDIMPOSTO%TYPE,
   P_CDEMPRESA   IN EMPRESA.CDEMPRESA%TYPE,
   P_CDINSCESTA  IN EMPRESA.CDINSCESTA%TYPE,
   P_DTINICIAL   IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_DTFINAL     IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_TIPODECLARA IN NOTAFISCAL.IDSTATUS%TYPE,
   P_FORMAPRES   IN NOTAFISCAL.IDSTATUS%TYPE,
   P_IDGIICMS    IN NOTAFISCAL.IDSTATUS%TYPE,
   P_IDGESTOQ    IN NOTAFISCAL.IDSTATUS%TYPE,
   P_NRSEQARQMAG IN ARQMAGNETICO.NRSEQARQMAG%TYPE,
   P_LIVROMAG    IN NOTAFISCAL.NRLANCTONF%TYPE)
AS
   V_STLINHA      VARCHAR2(500);
   V_DTPOSINIANT  DATE;
   V_DTPOSFIMANT  DATE;
   V_DTPOSINIATUA DATE;
   V_DTPOSFIMATUA DATE;
   V_QTDETOTAL    NUMBER;
   V_SOMAAUX      NUMBER;
   V_VRESTINIANT  NUMBER;
   V_ESTINIANT      DATE;
   V_VRESTFIMANT  NUMBER;
   V_ESTFIMANT      DATE;
   V_VRESTINIATUA NUMBER;
   V_ESTINIATUA     DATE;
   V_VRESTFIMATUA NUMBER;
   V_ESTFIMATUA     DATE;
   V_CONT         NUMBER;
BEGIN
   V_CONT := 0;

   V_SOMAAUX      := 0;
   V_VRESTINIANT  := 0;
   V_VRESTFIMANT  := 0;
   V_VRESTINIATUA := 0;
   V_VRESTFIMATUA := 0;

   /*REGISTRO 1 - CABEALHO DO ARQUIVO*/
   V_STLINHA := '1'||'Arquivo de carga DIEF';
   V_CONT := V_CONT + 1;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     (LPAD(TO_CHAR(V_CONT),10,'0'), V_STLINHA, P_NRSEQARQMAG);

   /*REGISTRO 2 - PRINCIPAL*/
   V_STLINHA := '';
   V_QTDETOTAL := 0;

   FOR C_REGISTROP IN (SELECT VRNORMDEBI, VRESTOCRED, T.DSITEMMAPR AS DESCOC,
                              VROUTRDEBI, VRNORMCRED, VROUTRCRED, VRESTODEBI, VRDEDUCAO,
                              VRSLDCRANTE, M.VRTOTAIMPOS, VRSALDOCRED, VRDIFALIQU, S.VRIMPOSUB,
                              VRTTCTBLDEB, VRTTCTBLCRE,
                              M.DTVENCGUIA, replace(replace(replace(M.CDRECEGUIA,'-',''),'.',''),'/','') as CDRECEGUIA, M.VRRECEGUIA, M.NRSEQUMAPAPU
                       FROM MAPAAPURAC M, MAPARECUP MR,
                            (SELECT MAX(DSITEMMAPR) AS DSITEMMAPR, IT.NRSEQUMAPAPU, IT.IDTIPOITMAPR
                             FROM ITMAPARECUP IT
                             GROUP BY IT.NRSEQUMAPAPU, IT.IDTIPOITMAPR) T,
                            (SELECT SUM(VRIMPOSTONF) AS VRIMPOSUB
                             FROM MAPAAPURAC M, IMPOSTONF IP, IMPOSTO I
                             WHERE M.CDEMPRESA    = P_CDEMPRESA     AND
                                   M.CDINSCESTA   = P_CDINSCESTA    AND
                                   M.CDIMPOSTO    = '80'            AND
                                   M.DTINIPERIODO = P_DTINICIAL     AND
                                   M.DTFIMPERIODO = P_DTFINAL       AND
                                   M.NRSEQUMAPAPU = IP.NRSEQUMAPAPU AND
                                   IP.CDFISCALNF  = '1'             AND
                                   IP.IDIMPOSTONF = '1') S
                       WHERE M.CDEMPRESA    = P_CDEMPRESA  AND
                             M.CDINSCESTA   = P_CDINSCESTA AND
                             M.CDIMPOSTO    = P_CDIMPOSTO  AND
                             M.DTINIPERIODO = P_DTINICIAL  AND
                             M.DTFIMPERIODO = P_DTFINAL    AND
                             M.NRSEQUMAPAPU = MR.NRSEQUMAPAPU AND
                             T.NRSEQUMAPAPU(+) = MR.NRSEQUMAPAPU AND
                             T.IDTIPOITMAPR(+) = 'OC') LOOP
      V_STLINHA := SUBSTR('2' ||  /*Tipo de Registro*/
                          RPAD(REPLACE(REPLACE(REPLACE(REPLACE(P_CDINSCESTA,'.',''),',',''),'-',''),'/',''),9,' ') || /* Inscrio Estadual*/
                          TO_CHAR(P_DTINICIAL, 'MM')   || /*mes de referncia*/
                          TO_CHAR(P_DTINICIAL, 'YYYY') || /*ano de referncia*/
                          P_FORMAPRES || /* Forma de Apresentao */
                          LTRIM(REPLACE(TO_CHAR(ABS(C_REGISTROP.VRNORMDEBI),'000000000.00'),'.','')) || /* Dbito do perodo*/
                          LTRIM(REPLACE(TO_CHAR(ABS(C_REGISTROP.VROUTRDEBI),'000000000.00'),'.','')) || /* Outros Dbitos*/
                          LTRIM(REPLACE(TO_CHAR(ABS(C_REGISTROP.VRESTOCRED),'000000000.00'),'.','')) || /* Estorno de Crdito*/
                          RPAD(NVL(C_REGISTROP.DESCOC, ' '), 30, ' ') || /* Desc Outros Crditos*/
                          '00000000000' || /* Outros dbitos*/
                          LTRIM(REPLACE(TO_CHAR(ABS(NVL(C_REGISTROP.VRNORMCRED, 0)),'000000000.00'),'.','')) || /* Crdito do Perodo*/
                          LTRIM(REPLACE(TO_CHAR(ABS(NVL(C_REGISTROP.VROUTRCRED, 0)),'000000000.00'),'.','')) || /* Outros Crditos*/
                          LTRIM(REPLACE(TO_CHAR(ABS(NVL(C_REGISTROP.VRESTODEBI, 0)),'000000000.00'),'.','')) || /* Estorno de Dbitos*/
                          LTRIM(REPLACE(TO_CHAR(ABS(NVL(C_REGISTROP.VRDEDUCAO, 0)),'000000000.00'),'.','')) || /* Dedues*/
                          RPAD(NVL(C_REGISTROP.DESCOC, ' '), 30, ' ') || /* Desc Outros Crditos*/
                          '00000000000' || /* Outros Crditos*/
                          LTRIM(REPLACE(TO_CHAR(ABS(NVL(C_REGISTROP.VRSLDCRANTE, 0)),'000000000.00'),'.','')) || /* Saldo Credor do perodo anterior*/
                          LTRIM(REPLACE(TO_CHAR(ABS(NVL(C_REGISTROP.VRTOTAIMPOS, 0)),'000000000.00'),'.','')) || /* ICMS a Recolher*/
                          LTRIM(REPLACE(TO_CHAR(ABS(NVL(C_REGISTROP.VRSALDOCRED, 0)),'000000000.00'),'.','')) || /* Saldo credor para o perodo seguinte*/
                          LTRIM(REPLACE(TO_CHAR(ABS(NVL(C_REGISTROP.VRDIFALIQU, 0)),'000000000.00'),'.','')) || /* Diferencial de alquota*/
                          LTRIM(REPLACE(TO_CHAR(ABS(NVL(C_REGISTROP.VRIMPOSUB,0)),'000000000.00'),'.','')) || /* Substituio Tributria*/
                          '00000000000'|| /* FUNDAP*/
                          '00000000000'|| /* Estimativa Supermercado*/
                          '00000000000'|| /* Estimativa Atacadista*/
                          RPAD(' ', 30, ' ') || /* Descrio Outro ICMS*/
                          '00000000000'|| /* Valor Outro ICMS*/
                          RPAD(' ', 30, ' ') || /* Descrio Outro ICMS*/
                          '00000000000'|| /* Valor Outro ICMS*/
                          RPAD(' ', 30, ' ') || /* Descrio Outro ICMS*/
                          '00000000000'|| /* Valor Outro ICMS*/
                          '00000000000'|| /* Valor Outro ICMS*/
                          P_TIPODECLARA, 1, 388); /* Tipo de Declarao*/
      V_QTDETOTAL := V_QTDETOTAL + 1;
      V_CONT := V_CONT + 1;
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        (LPAD(TO_CHAR(V_CONT),10,'0'), V_STLINHA, P_NRSEQARQMAG);

      /* REGISTRO 3 - CUSTOS E DESPESAS DO DIEF*/
      V_STLINHA := '';
      V_STLINHA := SUBSTR('3' ||
                          '00000000000'||
                          '00000000000'||
                          '00000000000'||
                          '00000000000'||
                          '00000000000'||
                          '00000000000'||
                          '00000000000'||
                          '00000000000'||
                          '00000000000'||
                          RPAD(' ', 30, ' ') ||
                          '00000000000'||
                          RPAD(' ', 30, ' ') ||
                          '00000000000'||
                          RPAD(' ', 30, ' ') ||
                          '00000000000'||
                          RPAD(' ', 30, ' ') ||
                          '00000000000'||
                          RPAD(' ', 30, ' ') ||
                          '00000000000'||
                          RPAD(' ', 30, ' ') ||
                          '00000000000', 1, 346);
      V_QTDETOTAL := V_QTDETOTAL + 1;
      V_CONT := V_CONT + 1;
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        (LPAD(TO_CHAR(V_CONT),10,'0'), V_STLINHA, P_NRSEQARQMAG);

      /* REGISTRO 4 - VENCIMENTOS DA DIEF*/
      V_STLINHA := '';
      V_STLINHA := '4' ||
                   C_REGISTROP.CDRECEGUIA ||
                   NVL(TO_CHAR(C_REGISTROP.DTVENCGUIA, 'DDMMYYYY'), '00000000') ||
                   LTRIM(REPLACE(TO_CHAR(ABS(NVL(C_REGISTROP.VRRECEGUIA,(NVL(C_REGISTROP.VRTOTAIMPOS, 0) + NVL(C_REGISTROP.VRDIFALIQU, 0) + NVL(C_REGISTROP.VRIMPOSUB, 0)))),'000000000.00'),'.',''));

      FOR C_GUIAS IN (SELECT replace(replace(replace(CDRECEITAGUIA,'-',''),'.',''),'/','') ||
                             NVL(TO_CHAR(DTVENCGUIACOMPL, 'DDMMYYYY'), '00000000') ||
                             LTRIM(REPLACE(TO_CHAR(ABS(NVL(VRRECEITAGUIA,0)),'000000000.00'),'.','')) AS DADOS
                        FROM GUIACOMPLMAPA
                       WHERE NRSEQUMAPAPU = C_REGISTROP.NRSEQUMAPAPU) LOOP

         IF C_GUIAS.DADOS IS NOT NULL THEN
            V_STLINHA := V_STLINHA||C_GUIAS.DADOS;
         END IF;

      END LOOP;

      V_STLINHA := RPAD(V_STLINHA,162,'0')||'0000'||
                                            '00000000'||
                                            '00000000000'; /*Guias Fora do Prazo*/
      V_QTDETOTAL := V_QTDETOTAL + 1;
      V_CONT := V_CONT + 1;
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        (LPAD(TO_CHAR(V_CONT),10,'0'), V_STLINHA, P_NRSEQARQMAG);
   END LOOP;

   /*REGISTRO 5 - RESUMO DE OPERAES DO DIEF*/
   FOR C_REGCFOP IN (SELECT '5' ||
                            C.CDFISCOPERNF ||
                            LTRIM(REPLACE(TO_CHAR(ABS(NVL(SUM(C.VRCONTABILNF), 0)),'000000000.00'),'.','')) ||
                            LTRIM(REPLACE(TO_CHAR(ABS(NVL(SUM(C.VRBASECALC), 0))  ,'000000000.00'),'.','')) ||
                            LTRIM(REPLACE(TO_CHAR(ABS(NVL(SUM(C.VRIMPOSTO), 0))   ,'000000000.00'),'.','')) ||
                            LTRIM(REPLACE(TO_CHAR(ABS(NVL(SUM(C.VRISENTO), 0))    ,'000000000.00'),'.','')) ||
                            LTRIM(REPLACE(TO_CHAR(ABS(NVL(SUM(ROUND((VRCONTABILNF-(VRBASECALC+VRISENTO))+VROUTROS,2)), 0))    ,'000000000.00'),'.',''))  AS LINHA

                     FROM (SELECT SUBSTR(CDFISCOPERNF,1,1)||
                                  CASE WHEN SUBSTR(CDFISCOPERNF,2,3) BETWEEN '100' AND '149' THEN '100'
                                       WHEN SUBSTR(CDFISCOPERNF,2,3) BETWEEN '150' AND '199' THEN '150'
                                       WHEN SUBSTR(CDFISCOPERNF,2,3) BETWEEN '200' AND '249' THEN '200'
                                       WHEN SUBSTR(CDFISCOPERNF,2,3) BETWEEN '250' AND '299' THEN '250'
                                       WHEN SUBSTR(CDFISCOPERNF,2,3) BETWEEN '300' AND '349' THEN '300'
                                       WHEN SUBSTR(CDFISCOPERNF,2,3) BETWEEN '350' AND '399' THEN '350'
                                       WHEN SUBSTR(CDFISCOPERNF,2,3) BETWEEN '400' AND '449' THEN '400'
                                       WHEN SUBSTR(CDFISCOPERNF,2,3) BETWEEN '450' AND '499' THEN '450'
                                       WHEN SUBSTR(CDFISCOPERNF,2,3) BETWEEN '500' AND '549' THEN '500'
                                       WHEN SUBSTR(CDFISCOPERNF,2,3) BETWEEN '550' AND '599' THEN '550'
                                       WHEN SUBSTR(CDFISCOPERNF,2,3) BETWEEN '600' AND '649' THEN '600'
                                       WHEN SUBSTR(CDFISCOPERNF,2,3) BETWEEN '650' AND '899' THEN '650'
                                       WHEN SUBSTR(CDFISCOPERNF,2,3) BETWEEN '900' AND '999' THEN '900'
                                  END AS CDFISCOPERNF,
                                  ROUND(VRCONTABILNF,2) AS VRCONTABILNF,
                                  DECODE(CDFISCALNF, '1', ROUND(VRBASECALCNF,2), 0) AS VRBASECALC,
                                  DECODE(CDFISCALNF, '1', ROUND(VRIMPOSTONF,2), 0) AS VRIMPOSTO,
                                  DECODE(CDFISCALNF, '2', ROUND(VRCONTABILNF,2), 0) AS VRISENTO,
                                  0 AS VROUTROS
                           FROM MAPAAPURAC M, IMPOSTONF I
                           WHERE M.CDEMPRESA    = P_CDEMPRESA   AND
                                 M.CDINSCESTA   = P_CDINSCESTA  AND
                                 M.CDIMPOSTO    = P_CDIMPOSTO   AND
                                 M.DTINIPERIODO = P_DTINICIAL   AND
                                 M.DTFIMPERIODO = P_DTFINAL     AND
                                 NVL(I.IDIMPOSTONF,'3') <> '3'  AND
                                 M.NRSEQUMAPAPU = I.NRSEQUMAPAPU AND
                                 SUBSTR(I.CDFISCOPERNF,1,1) IN ('1','5')
                           UNION ALL
                           SELECT SUBSTR(CDFISCOPERNF,1,1)||
                                  CASE WHEN SUBSTR(CDFISCOPERNF,2,3) BETWEEN '100' AND '149' THEN '100'
                                       WHEN SUBSTR(CDFISCOPERNF,2,3) BETWEEN '150' AND '199' THEN '150'
                                       WHEN SUBSTR(CDFISCOPERNF,2,3) BETWEEN '200' AND '249' THEN '200'
                                       WHEN SUBSTR(CDFISCOPERNF,2,3) BETWEEN '250' AND '299' THEN '250'
                                       WHEN SUBSTR(CDFISCOPERNF,2,3) BETWEEN '300' AND '349' THEN '300'
                                       WHEN SUBSTR(CDFISCOPERNF,2,3) BETWEEN '350' AND '399' THEN '350'
                                       WHEN SUBSTR(CDFISCOPERNF,2,3) BETWEEN '400' AND '499' THEN '400'
                                       WHEN SUBSTR(CDFISCOPERNF,2,3) BETWEEN '500' AND '549' THEN '500'
                                       WHEN SUBSTR(CDFISCOPERNF,2,3) BETWEEN '550' AND '599' THEN '550'
                                       WHEN SUBSTR(CDFISCOPERNF,2,3) BETWEEN '600' AND '649' THEN '600'
                                       WHEN SUBSTR(CDFISCOPERNF,2,3) BETWEEN '650' AND '899' THEN '650'
                                       WHEN SUBSTR(CDFISCOPERNF,2,3) BETWEEN '900' AND '999' THEN '900'
                                  END AS CDFISCOPERNF,
                                  ROUND(VRCONTABILNF,2) AS VRCONTABILNF,
                                  DECODE(CDFISCALNF, '1', ROUND(VRBASECALCNF,2), 0) AS VRBASECALC,
                                  DECODE(CDFISCALNF, '1', ROUND(VRIMPOSTONF,2), 0) AS VRIMPOSTO,
                                  DECODE(CDFISCALNF, '2', ROUND(VRCONTABILNF,2), 0) AS VRISENTO,
                                  0 AS VROUTROS
                           FROM MAPAAPURAC M, IMPOSTONF I
                           WHERE M.CDEMPRESA    = P_CDEMPRESA   AND
                                 M.CDINSCESTA   = P_CDINSCESTA  AND
                                 M.CDIMPOSTO    = P_CDIMPOSTO   AND
                                 M.DTINIPERIODO = P_DTINICIAL   AND
                                 M.DTFIMPERIODO = P_DTFINAL     AND
                                 M.NRSEQUMAPAPU = I.NRSEQUMAPAPU AND
                                 NVL(I.IDIMPOSTONF,'3') <> '3'  AND
                                 SUBSTR(I.CDFISCOPERNF,1,1) IN ('2','6')
                           UNION ALL
                           SELECT SUBSTR(CDFISCOPERNF,1,1)||
                                  CASE WHEN SUBSTR(CDFISCOPERNF,2,3) BETWEEN '100' AND '199' THEN '100'
                                       WHEN SUBSTR(CDFISCOPERNF,2,3) BETWEEN '200' AND '249' THEN '200'
                                       WHEN SUBSTR(CDFISCOPERNF,2,3) BETWEEN '250' AND '299' THEN '250'
                                       WHEN SUBSTR(CDFISCOPERNF,2,3) BETWEEN '300' AND '349' THEN '300'
                                       WHEN SUBSTR(CDFISCOPERNF,2,3) BETWEEN '350' AND '499' THEN '350'
                                       WHEN SUBSTR(CDFISCOPERNF,2,3) BETWEEN '500' AND '549' THEN '500'
                                       WHEN SUBSTR(CDFISCOPERNF,2,3) BETWEEN '550' AND '649' THEN '550'
                                       WHEN SUBSTR(CDFISCOPERNF,2,3) BETWEEN '650' AND '899' THEN '650'
                                       WHEN SUBSTR(CDFISCOPERNF,2,3) BETWEEN '900' AND '999' THEN '900'
                                  END AS CDFISCOPERNF,
                                  ROUND(VRCONTABILNF,2) AS VRCONTABILNF,
                                  DECODE(CDFISCALNF, '1', ROUND(VRBASECALCNF,2), 0) AS VRBASECALC,
                                  DECODE(CDFISCALNF, '1', ROUND(VRIMPOSTONF,2), 0) AS VRIMPOSTO,
                                  DECODE(CDFISCALNF, '2', ROUND(VRCONTABILNF,2), 0) AS VRISENTO,
                                  0 AS VROUTROS
                           FROM MAPAAPURAC M, IMPOSTONF I
                           WHERE M.CDEMPRESA    = P_CDEMPRESA   AND
                                 M.CDINSCESTA   = P_CDINSCESTA  AND
                                 M.CDIMPOSTO    = P_CDIMPOSTO   AND
                                 M.DTINIPERIODO = P_DTINICIAL   AND
                                 M.DTFIMPERIODO = P_DTFINAL     AND
                                 M.NRSEQUMAPAPU = I.NRSEQUMAPAPU AND
                                 NVL(I.IDIMPOSTONF,'3') <> '3'  AND
                                 SUBSTR(I.CDFISCOPERNF,1,1) IN ('3','7')) C
                     GROUP BY C.CDFISCOPERNF
                     ORDER BY C.CDFISCOPERNF) LOOP
      V_STLINHA := SUBSTR(C_REGCFOP.LINHA, 1, 60);
      V_QTDETOTAL := V_QTDETOTAL + 1;
      V_CONT := V_CONT + 1;
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        (LPAD(TO_CHAR(V_CONT),10,'0'), V_STLINHA, P_NRSEQARQMAG);
   END LOOP;

   /* REGISTRO L - Valor Adicionado por Municipio */
   FOR C_REGMUN IN (SELECT CDMUNIEXPO, SUM(VRSAIDA-VRENTRADA) AS VALOR_ADICIONADO
                      FROM (SELECT SUM(DECODE(IDENTRSAIDOP, 'S', ROUND(I.VRCONTABILNF,2), 0)) AS VRSAIDA,
                                   SUM(DECODE(IDENTRSAIDOP, 'E', ROUND(I.VRCONTABILNF,2), 0)) AS VRENTRADA,
                                   CDMUNIEXPO
                              FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I, CFOPLIVROMAG L,
                                   FILIAL F, ENDEFILI EF, MUNICIPIO MU
                             WHERE M.CDEMPRESA = P_CDEMPRESA
                               AND M.CDINSCESTA = P_CDINSCESTA
                               AND M.CDIMPOSTO = P_CDIMPOSTO
                               AND M.DTINIPERIODO >= P_DTINICIAL
                               AND M.DTFIMPERIODO <= P_DTFINAL
                               AND M.NRSEQUMAPAPU = I.NRSEQUMAPAPU
                               AND I.NRLANCTONF = N.NRLANCTONF
                               AND I.CDFILIAL =  N.CDFILIAL
                               AND ((IDIMPOSTONF <> '3') OR (IDIMPOSTONF IS NULL))
                               AND L.CDLAYOUTLMAG = '002'
                               AND I.CDFISCOPERNF = L.CDCFOPLMAG
                               AND DECODE(IDENTRSAIDOP, 'E', CDFILIRECE, CDFILIEMIT) = F.CDFILIAL
                               AND NVL(IDTPENDEFILI,'P') = 'P'
                               AND EF.CDFILIAL = F.CDFILIAL
                               AND EF.CDPAIS = MU.CDPAIS
                               AND EF.SGESTADO = MU.SGESTADO
                               AND EF.CDMUNICIPIO = MU.CDMUNICIPIO
                               AND L.CDLIVROMAG = P_LIVROMAG
                             GROUP BY CDMUNIEXPO)
                     WHERE (VRSAIDA-VRENTRADA) > 0
                     GROUP BY CDMUNIEXPO) LOOP

      V_STLINHA := 'L'||
                   LPAD(NVL(C_REGMUN.CDMUNIEXPO,'0'),5,'0')||
                   LTRIM(REPLACE(TO_CHAR(NVL(C_REGMUN.VALOR_ADICIONADO, 0),'00000000.00'),'.',''));

      V_QTDETOTAL := V_QTDETOTAL + 1;
      V_CONT := V_CONT + 1;
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        (LPAD(TO_CHAR(V_CONT),10,'0'), V_STLINHA, P_NRSEQARQMAG);

   END LOOP;

   /* REGISTRO M - GI-ICMS */
   IF P_IDGIICMS = 'S' THEN
      V_STLINHA := '';
   END IF;

   /* REGISTRO N - ESTOQUE */
   IF P_IDGESTOQ = 'S' THEN
      /* POSIO DE ESTOQUE DO ANO ANTERIOR*/
      V_DTPOSINIANT := TO_DATE('01/01'||TO_CHAR(ADD_MONTHS(P_DTINICIAL, -13), 'YYYY')); /* DATA INICIAL DO ANO ANTERIOR*/
      V_DTPOSFIMANT := TO_DATE('01/01'||TO_CHAR(P_DTINICIAL, 'YYYY'));
      /* POSIO DE ESTOQUE ATUAL*/
      V_DTPOSINIATUA := TO_DATE('01/01'||TO_CHAR(P_DTINICIAL, 'YYYY')); /* DATA INICIAL DO ANO ANTERIOR*/
      V_DTPOSFIMATUA := TO_DATE('01/01'||TO_CHAR(ADD_MONTHS(P_DTINICIAL, 13), 'YYYY'));


      FOR C_REGEST IN (SELECT F.CDFILIAL, F.CDINSCESTA
                         FROM FILIAL F
                        WHERE F.CDEMPRESA = P_CDEMPRESA
                          AND F.CDINSCESTA = P_CDINSCESTA
                        ORDER BY CDFILIAL) LOOP

         BEGIN
            SELECT SUM(I.VRTOTINVFISC)
              INTO V_SOMAAUX
              FROM INVENTFISC I, PRODUTO P
             WHERE I.CDEMPRESA    = P_CDEMPRESA
              AND I.CDINSCESTA   = C_REGEST.CDINSCESTA
              AND I.CDPRODUTO    = P.CDPRODUTO
              AND I.QTESTINVFISC <> 0
              AND I.DTINVEFISCAL = (SELECT MAX(DTINVEFISCAL)
                                             FROM INVENTFISC V  , PRODUTO PR
                                            WHERE V.DTINVEFISCAL <= V_DTPOSINIANT
                                             AND V.CDEMPRESA = P_CDEMPRESA
                                             AND V.CDINSCESTA   = C_REGEST.CDINSCESTA
                                             AND V.CDPRODUTO    = PR.CDPRODUTO
                                             AND V.QTESTINVFISC <> 0);

         EXCEPTION
            WHEN No_Data_Found THEN
               V_SOMAAUX := NULL;
         END;

         V_VRESTINIANT := V_VRESTINIANT + NVL(V_SOMAAUX, 0);

         BEGIN
            SELECT SUM(I.VRTOTINVFISC)
              INTO V_SOMAAUX
              FROM INVENTFISC I, PRODUTO P
             WHERE I.CDEMPRESA    = P_CDEMPRESA
              AND I.CDINSCESTA   = C_REGEST.CDINSCESTA
              AND I.CDPRODUTO    = P.CDPRODUTO
              AND I.QTESTINVFISC <> 0
              AND I.DTINVEFISCAL = (SELECT   MAX(DTINVEFISCAL)
                                             FROM INVENTFISC V  , PRODUTO PR
                                            WHERE V.DTINVEFISCAL <= V_DTPOSFIMANT
                                             AND V.CDEMPRESA = P_CDEMPRESA
                                             AND V.CDINSCESTA   = C_REGEST.CDINSCESTA
                                             AND V.CDPRODUTO    = PR.CDPRODUTO
                                             AND V.QTESTINVFISC <> 0);

         EXCEPTION
            WHEN No_Data_Found THEN
               V_SOMAAUX := NULL;
         END;

         V_VRESTFIMANT := V_VRESTFIMANT + NVL(V_SOMAAUX, 0);

         BEGIN
            SELECT SUM(I.VRTOTINVFISC)
              INTO V_SOMAAUX
              FROM INVENTFISC I, PRODUTO P
             WHERE I.CDEMPRESA    = P_CDEMPRESA
              AND I.CDINSCESTA   = C_REGEST.CDINSCESTA
              AND I.CDPRODUTO    = P.CDPRODUTO
              AND I.QTESTINVFISC <> 0
              AND I.DTINVEFISCAL = (SELECT   MAX(DTINVEFISCAL)
                                             FROM INVENTFISC V  , PRODUTO PR
                                            WHERE V.DTINVEFISCAL <= V_DTPOSINIATUA
                                             AND V.CDEMPRESA = P_CDEMPRESA
                                             AND V.CDINSCESTA   = C_REGEST.CDINSCESTA
                                             AND V.CDPRODUTO    = PR.CDPRODUTO
                                             AND V.QTESTINVFISC <> 0);

         EXCEPTION
            WHEN No_Data_Found THEN
               V_SOMAAUX := NULL;
         END;

         V_VRESTINIATUA := V_VRESTINIATUA + NVL(V_SOMAAUX, 0);


         BEGIN
            SELECT SUM(I.VRTOTINVFISC)
              INTO V_SOMAAUX
              FROM INVENTFISC I, PRODUTO P
            WHERE I.CDEMPRESA    = P_CDEMPRESA
              AND I.CDINSCESTA   = C_REGEST.CDINSCESTA
              AND I.CDPRODUTO    = P.CDPRODUTO
              AND I.QTESTINVFISC <> 0
               AND I.DTINVEFISCAL = (SELECT   MAX(DTINVEFISCAL)
                                             FROM INVENTFISC V  , PRODUTO PR
                                            WHERE V.DTINVEFISCAL <= V_DTPOSFIMATUA
                                             AND V.CDEMPRESA = P_CDEMPRESA
                                             AND V.CDINSCESTA   = C_REGEST.CDINSCESTA
                                             AND V.CDPRODUTO    = PR.CDPRODUTO
                                             AND V.QTESTINVFISC <> 0);
         EXCEPTION
            WHEN No_Data_Found THEN
               V_SOMAAUX := NULL;
         END;

         V_VRESTFIMATUA := V_VRESTFIMATUA + NVL(V_SOMAAUX, 0);

      END LOOP;

      V_STLINHA := 'N' ||
                   LTRIM(REPLACE(TO_CHAR(NVL(V_VRESTINIANT, 0),'00000000.00'),'.',''))     ||
                   LTRIM(REPLACE(TO_CHAR(NVL(V_VRESTFIMANT, 0),'00000000.00'),'.',''))     ||
                   LTRIM(REPLACE(TO_CHAR(NVL(V_VRESTINIATUA, 0),'00000000.00'),'.',''))    ||
                   LTRIM(REPLACE(TO_CHAR(NVL(V_VRESTFIMATUA, 0),'00000000.00'),'.',''));
      V_QTDETOTAL := V_QTDETOTAL + 1;
      V_CONT := V_CONT + 1;
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        (LPAD(TO_CHAR(V_CONT),10,'0'), V_STLINHA, P_NRSEQARQMAG);
   END IF;
   /* REGISTRO D - REGISTRO FINAL*/
   IF P_TIPODECLARA = '0'THEN
      V_STLINHA := 'D' ||
                  LTRIM(TO_CHAR(V_QTDETOTAL + 2,'00000')) ||
                  LTRIM(TO_CHAR(V_QTDETOTAL,'00000')) ||
                  '00000' ||
                  '00000';
   ELSE
      V_STLINHA := 'D' ||
                  LTRIM(TO_CHAR(V_QTDETOTAL + 2,'00000')) ||
                  '00000' ||
                  LTRIM(TO_CHAR(V_QTDETOTAL,'00000')) ||
                  '00000';
   END IF;
   V_CONT := V_CONT + 1;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     (LPAD(TO_CHAR(V_CONT),10,'0'), V_STLINHA, P_NRSEQARQMAG);
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ARQUIVO_DIEF_ES','5.33.000'); END;
/

